
-- matIDByElement v1.0 for 3ds Max 9 - (c) Ariel Chai, 11.02.08
-- Makes a seperate Material ID for each element. 
-- Useful for uv seperation by colors, through a diffuse bake (multicolor material supplied) - make sure to to turn on the fuziness in photoshop's color picker.
--
-- Note: This will convert your mesh to an editable poly
--

m = selection

currentID = 2
if(classof m[1] != Editable_Poly) then convertTo m[1] PolyMeshObject
subobjectLevel = 4


faceCount = m[1].GetNumFaces()
$.EditablePoly.SetSelection #Face #{1..faceCount}
$.EditablePoly.setMaterialIndex 1 1

-- Set a different ID for each Element
for f = 1 to 

faceCount do (
	
$.EditablePoly.SetSelection #Face #{f}
	fI = polyop.getFaceMatID m[1] f

	-- Grow the selection and apply a new ID
	if fI == 1 then (
		selFaces = m[1].selectedFaces
		numFaces1 = 
selFaces.count
		numFaces2 = 0


		-- Grows the face selection to the whole element
		while numFaces1 > numFaces2 do (
			selFaces = m[1].selectedFaces
			numFaces2 = 
selFaces.count
			$.EditablePoly.GrowSelection ()
			selFaces = m[1].selectedFaces
			numFaces1 = 
selFaces.count
		)

		-- Assign an ID
		$.EditablePoly.setMaterialIndex currentID 1
		currentID += 1
	)
)


